From 1b9a641b32f6d1c6236ae8293e686f3b2f987a7a Mon Sep 17 00:00:00 2001
From: Rob Jonson <rob@hobbyistsoftware.com>
Date: Sun, 25 Sep 2011 23:27:59 +0100
Subject: [PATCH 09/10] update in_enqueue and in_play to handle mrls better
 stripslashes() is removed as it relates to old broken
 encoding in the web client a simplistic uriFromMrl
 function is used to support uri and file types as
 input.

---
 share/lua/intf/modules/httprequests.lua |   20 +++++++++++++++-----
 1 files changed, 15 insertions(+), 5 deletions(-)

diff --git a/share/lua/intf/modules/httprequests.lua b/share/lua/intf/modules/httprequests.lua
index bb34de4..335a07c 100644
--- a/share/lua/intf/modules/httprequests.lua
+++ b/share/lua/intf/modules/httprequests.lua
@@ -27,8 +27,18 @@ module("httprequests",package.seeall)
 
 --input utilities
 
-local function stripslashes(s)
-  return string.gsub(s,"\\(.)","%1")
+--fixme simplistic implementation. This could be improved.
+function uriFromMrl(mrl)
+
+	--presence of :// indicates this is already a uri
+	if string.find(mrl,"://") then
+		return mrl
+	end
+
+	--otherwise, use make_uri
+	local uri=vlc.strings.make_uri(mrl)
+	return uri
+
 end
 
 --Round the number to the specified precision
@@ -87,11 +97,11 @@ processcommands = function ()
 	  end
 	  vlc.msg.err( "</options>" )
 	  --]]
-	  vlc.playlist.add({{path=stripslashes(input),options=options}})
+	  vlc.playlist.add({{path=uriFromMrl(input),options=options}})
 	elseif command == "addsubtitle" then
-	  vlc.input.add_subtitle (stripslashes(val))
+	  vlc.input.add_subtitle (uriFromMrl(val))
 	elseif command == "in_enqueue" then
-	  vlc.playlist.enqueue({{path=stripslashes(input),options=options}})
+	  vlc.playlist.enqueue({{path=uriFromMrl(input),options=options}})
 	elseif command == "pl_play" then
 	  if id == -1 then
 		vlc.playlist.play()
-- 
1.7.5

